package eu.univento.teamvento.commands;

import eu.univento.commons.player.Rank;
import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.teamvento.TeamVento;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.ComponentBuilder;
import net.md_5.bungee.api.chat.HoverEvent;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.List;

/**
 * @author joethei
 * @version 0.1
 */
public class WorldList extends AutoCommand<TeamVento> {

    public WorldList(TeamVento plugin, String command, String description, String... aliases) {
        super(plugin, command, description, aliases);
    }

    @Override
    public boolean execute(CommandSender sender, String label, String[] args) {
        if(sender instanceof Player) {
            CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
            if(p.getDatabasePlayer().isAllowed(Rank.Supporter)) {
                p.sendMessage("§cAll worlds");
                for(String world : TeamVento.getCfg().getKeys(true)) {
                    TextComponent text = new TextComponent("§a- " + world);
                    text.setClickEvent(new ClickEvent(ClickEvent.Action.RUN_COMMAND, "/wtp " + world));
                    text.setHoverEvent(new HoverEvent(HoverEvent.Action.SHOW_TEXT, new ComponentBuilder("In die Welt").create()));
                    p.spigot().sendMessage(text);
                }
            }else{
                p.sendMessage(p.getMessages().NO_PERMS());
            }
        }else{
            sender.sendMessage(Messages.Console.NOT_A_PLAYER);
        }
        return true;
    }

    @Override
    public List<String> tabComplete(CommandSender sender, String label, String[] args) {
        return null;
    }
}